XONSH(1)

NAME
xonsh - Pythonish, BASHwards looking shell

DESCRIPTION
Xonsh is a Python-ish shell language and command prompt. Unlike other shells, xonsh is based on Python, with additional syntax added that makes calling subprocess commands, manipulating the environment, and dealing with the file system easy. Xonsh supports all normal Python constructs and a subset of those available in bash.

usage: xonsh [-h] [-V] [-c COMMAND] [-n] [-i] [-l] [--rc RC [RC ...]]

    [--no-rc] [--no-env] [--no-script-cache] [--cache-everything] [-D ITEM] [-st SHELL_TYPE] [--timings] [--save-origin-env] [--load-origin-env] [script-file] ...

xonsh

  positional arguments:

script-file
    If present, execute the script in script-file and exit.

args
    Additional arguments to the script specified by script-file.

  options:

-h, --help
    Show help and exit.

-V, --version
    Show version information and exit.

-c COMMAND
    Run a single command and exit.

-n, --no-execute
    Parse and compile the code but do not execute it. Exit non-zero on errors. Use the `xonsh check` subcommand for more options e.g. to check several files.

-i, --interactive
    Force running in interactive mode.

-l, --login
    Run as a login shell.

--rc RC [RC ...]
    The xonshrc files to load, these may be either xonsh files or directories containing xonsh files

--no-rc
    Do not load any xonsh RC files. Argument --rc will be ignored if --no-rc is set.

--no-env
    Do not inherit parent environment variables.

--no-script-cache
    Do not cache scripts as they are run.

--cache-everything
    Use a cache, even for interactive commands.

-D ITEM
    Define an environment variable, in the form of -DVAR=VAL or inherit existing variable with -DVAR. May be used many times.

-st, --shell-type SHELL_TYPE
    What kind of shell should be used. Possible options: b, best, d, dumb, ptk, prompt-toolkit, prompt_toolkit, rand, random, rl, readline. Warning! If set this overrides $SHELL_TYPE variable.

--timings
    Prints timing information before the prompt is shown. This is useful while tracking down performance issues and investigating startup times.

--save-origin-env
    Save origin environment variables before running xonsh. Use --load-origin-env to run xonsh with saved origin environment.

--load-origin-env
    Load origin environment variables that were saved before running xonsh by using --save-origin-env

  subcommands:

format
    Format xonsh source files. Run `xonsh format --help` for options.

check
    Check xonsh source files for syntax errors without running them. Run `xonsh check --help` for options.

lint
    Lint xonsh source files for likely mistakes. Run `xonsh lint --help` for options.

FILES
The run control file is written in xonsh script and executed once at start-up.

/etc/xonshrc
    System-wide run control file

~/.xonshrc
    Per-user run control file

In addition to the run control file, a JSON formatted static file can be used to set runtime parameters and environment variables before the xonshrc files are executed.

$XDG_CONFIG_HOME/xonsh/config.json
    Per-user static config file